class lldp ($ensure       = 'present',
            $autoupdate   = $lldp::defaults::autoupdate,
            $package_name = $lldp::defaults::package_name,
            $service_name = $lldp::defaults::service_name,
            $pidfile      = $lldp::defaults::pidfile,
           ) inherits lldp::defaults {
  case $ensure {
    'present': {
      if $autoupdate {
        $pkg_ensure = 'latest'
      } else {
        $pkg_ensure = 'present'
      }
      $svc_ensure   = 'running'
      $svc_enable   = true
      $file_ensure  = 'present'
    }
    'absent': {
      $pkg_ensure   = 'absent'
      $svc_ensure   = 'stopped'
      $svc_enable   = false
    }
    'purged': {
      $pkg_ensure   = 'purged'
      $svc_ensure   = 'stopped'
      $svc_enable   = false
    }
  }

  package {$package_name:
    ensure => $pkg_ensure,
  } -> service {$service_name:
    ensure => $svc_ensure,
    enable => $svc_enable,
  }

  # OpenLLDP doesn't write a pidfile, so we can't use monit::monitor
  # to monitor it.  Some other LLDP implementations do.
  if $pidfile {
    @monit::monitor {$service_name:
      pidfile => $pidfile,
      ensure  => $file_ensure,
      tag     => 'default',
    }
  }
}
